table.insert( actions,
{
	id          = "GW_ADAPTER",
	name 		= "GW-Adapter",
	description = "Adapter that allows GW spells to function.",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_adapter.png",
	type 		= ACTION_TYPE_UTILITY,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_ADAPTER
	spawn_probability                 = "1,0,0,0,0,0,0", -- GW_ADAPTER
	price = 0,
	mana = 0,
	max_uses = -1,
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_adapter_extra.xml",
	action 		= function()
		draw_actions( 1, true )
	end,
})

table.insert( actions,
{
	id          = "GW_LONG_BARREL",
	name 		= "GW-Long Barrel",
	description = "A longer barrel that helps accelerate projectiles. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_long_barrel.png",
	type 		= ACTION_TYPE_UTILITY,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_LONG_BARREL
	spawn_probability                 = "5,0,0,0,0,0,0", -- GW_LONG_BARREL
	price = 250,
	mana = 25,
	max_uses = -1,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			c.extra_entities = c.extra_entities .. "mods/mwp_gunwand/files/entities/projectiles/gw_long_barrel.xml,"
			draw_actions( 1, true )
		end
	end,
})

table.insert( actions,
{
	id          = "GW_COIL_DRIVE",
	name 		= "GW-Coil Drive",
	description = "An electro-magnetic conductor that accelerates projectiles to extreme speeds. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_railgun_module.png",
	type 		= ACTION_TYPE_UTILITY,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_RAILGUN_MODULE
	spawn_probability                 = "1,0,0,0,0,0,0", -- GW_RAILGUN_MODULE
	price = 500,
	mana = 50,
	max_uses = -1,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			c.extra_entities = c.extra_entities .. "mods/mwp_gunwand/files/entities/projectiles/gw_accelerator.xml,"
			draw_actions( 1, true )
		end
	end,
})

table.insert( actions,
{
	id          = "GW_SCOPE",
	name 		= "GW-Scope",
	description = "A scope for precise long range attacks. Press [SPRAY] + [INTERACT] to use it. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_scope.png",
	type 		= ACTION_TYPE_UTILITY,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_SCOPE
	spawn_probability                 = "10,0,1,1,1,1,1", -- GW_SCOPE
	price = 50,
	mana = 10,
	max_uses = -1,
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_scope_extra.xml",
	action 		= function()
		draw_actions( 1, true )
	end,
})

table.insert( actions,
{
	id          = "GW_PISTOL",
	name 		= "GW-Pistol",
	description = "Pistol bullet spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_pistol.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_PISTOL
	spawn_probability                 = "10,1,1,0,0,0,0", -- GW_PISTOL
	price = 10,
	mana = 15,
	max_uses = -1,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_pistol.xml")
			c.fire_rate_wait = c.fire_rate_wait + 9
			c.damage_critical_chance = c.damage_critical_chance + 5
		end
	end,
})

table.insert( actions,
{
	id          = "GW_SMG",
	name 		= "GW-SMG",
	description = "SMG bullet spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_smg.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_SMG
	spawn_probability                 = "5,1,1,1,0,0,0", -- GW_SMG
	price = 100,
	mana = 4.5,
	max_uses = 999,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_smg.xml")
			c.fire_rate_wait = c.fire_rate_wait + 4
			c.damage_critical_chance = c.damage_critical_chance + 5
		end
	end,
})

table.insert( actions,
{
	id          = "GW_HMG",
	name 		= "GW-HMG",
	description = "HMG bullet spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_hmg.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_HMG
	spawn_probability                 = "1,0,1,1,1,0,0", -- GW_HMG
	price = 500,
	mana = 10,
	max_uses = 500,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")

		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_hmg.xml")
			c.fire_rate_wait = c.fire_rate_wait + 7
			c.damage_critical_chance = c.damage_critical_chance + 10
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 25
		end
	end,
})

table.insert( actions,
{
	id          = "GW_SHOTGUN",
	name 		= "GW-Shotgun",
	description = "Shotgun shell spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_shotgun.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_SHOTGUN
	spawn_probability                 = "5,1,1,1,0,0,0", -- GW_SHOTGUN
	price = 400,
	mana = 50,
	max_uses = 99,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_shotgun.xml")
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.damage_critical_chance = c.damage_critical_chance + 10
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 25
		end
	end,
})

table.insert( actions,
{
	id          = "GW_SNIPER",
	name 		= "GW-Sniper",
	description = "Sniper bullet spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_sniper.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_SNIPER
	spawn_probability                 = "5,0,1,1,1,0,0", -- GW_SNIPER
	price = 500,
	mana = 50,
	max_uses = 99,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_sniper.xml")
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.damage_critical_chance = c.damage_critical_chance + 25
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 25
			c.speed_multiplier = 1
		end
	end,
})

table.insert( actions,
{
	id          = "GW_CANNON",
	name 		= "GW-Cannon",
	description = "Cannon shell spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_cannon.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_CANNON
	spawn_probability                 = "1,0,0,0,0,1,1", -- GW_CANNON
	price = 2000,
	mana = 250,
	max_uses = 25,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_cannon.xml")
			c.fire_rate_wait = c.fire_rate_wait + 120
			c.gore_particles    = c.gore_particles + 10
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 500
		end
	end,
})

table.insert( actions,
{
	id          = "GW_FLAK",
	name 		= "GW-Flak Cannon",
	description = "Flak shell spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_flak_cannon.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_FLAK
	spawn_probability                 = "1,0,0,0,0,1,1", -- GW_FLAK
	price = 1000,
	mana = 100,
	max_uses = 25,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_flak_cannon_no_sound.xml")
			c.fire_rate_wait = c.fire_rate_wait + 15
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 250
		end
	end,
})

table.insert( actions,
{
	id          = "GW_MISSILE",
	name 		= "GW-Missile Launcher",
	description = "Missile spell. Hold [SPRAY] and press [USE WAND] to launch a guided missile, release [SPRAY] to detonate it. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_missile_launcher.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_MISSILE
	spawn_probability                 = "1,0,0,0,0,1,1", -- GW_MISSILE
	price = 2000,
	mana = 250,
	max_uses = 25,
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_missile_extra.xml",
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		local guidedSprite = EntityGetWithTag("gw_guided")
		local G_SpriteTarget = EntityGetFirstComponent(guidedSprite[1], "SpriteComponent", "gw_guided_sprite")
		local is_guide_on = ComponentGetValue(G_SpriteTarget, "visible")
		
		if adapter_on == true and (tonumber(is_guide_on)) == 0 then
			add_projectile("mods/mwp_gunwand/files/actions/gw_missile_launcher.xml")
			c.fire_rate_wait = c.fire_rate_wait + 120
			c.gore_particles    = c.gore_particles + 10
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 100
		end
		
		if adapter_on == true and (tonumber(is_guide_on)) == 1 then
			add_projectile("mods/mwp_gunwand/files/actions/gw_missile_guided.xml")
			c.fire_rate_wait = c.fire_rate_wait + 120
			c.gore_particles    = c.gore_particles + 10
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 100
		end
	end,
})

table.insert( actions,
{
	id 			= "GW_G_LAUNCHER",
	name 		= "GW-Grenade Launcher",
	description = "Explosive grenade spell. Press [SPRAY] + [DOWN] to detonate all grenades. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_g_launcher.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level	           = "0,1,2,3,4,5,6", -- GW_G_LAUNCHER
	spawn_probability	   = "1,0,0,1,1,1,0", -- GW_G_LAUNCHER
	price =1000,
	mana = 250,
	max_uses	= 25, 
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_g_launcher_extra.xml",
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_g_launcher.xml")
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.bounces = c.bounces + 2
		end
	end,
})

table.insert( actions,
{
	id 			= "GW_S_LAUNCHER",
	name 		= "GW-Shrapnel Grenade Launcher",
	description = "Shrapnel grenade spell. Press [SPRAY] + [DOWN] to detonate all grenades.  \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_s_launcher.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level	           = "0,1,2,3,4,5,6", -- GW_S_LAUNCHER
	spawn_probability	   = "1,0,0,1,1,1,0", -- GW_S_LAUNCHER
	price =1000,
	mana = 250,
	max_uses	= 25, 
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_s_launcher_extra.xml",
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_s_launcher.xml")
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.bounces = c.bounces + 2
		end
	end,
})

table.insert( actions,
{
	id 			= "GW_F_LAUNCHER",
	name 		= "GW-Incendiary Grenade Launcher",
	description = "Incendiary grenade spell. Press [SPRAY] + [DOWN] to detonate all grenades.  \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_f_launcher.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level	           = "0,1,2,3,4,5,6", -- GW_F_LAUNCHER
	spawn_probability	   = "1,0,0,1,1,1,0", -- GW_F_LAUNCHER
	price =1000,
	mana = 250,
	max_uses	= 25, 
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_f_launcher_extra.xml",
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_f_launcher.xml")
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.bounces = c.bounces + 2
		end
	end,
})

table.insert( actions,
{
	id 			= "GW_A_LAUNCHER",
	name 		= "GW-Acid Grenade Launcher",
	description = "Acid grenade spell. Press [SPRAY] + [DOWN] to detonate all grenades.  \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_a_launcher.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level	           = "0,1,2,3,4,5,6", -- GW_A_LAUNCHER
	spawn_probability	   = "1,0,0,1,1,1,0", -- GW_A_LAUNCHER
	price =1000,
	mana = 250,
	max_uses	= 25, 
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_a_launcher_extra.xml",
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_a_launcher.xml")
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.bounces = c.bounces + 2
		end
	end,
})

table.insert( actions,
{
	id 			= "GW_T_LAUNCHER",
	name 		= "GW-Trigger Grenade Launcher",
	description = "Grenade spell that trigger another spell on death. Press [SPRAY] + [DOWN] to detonate all grenades.  \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_t_launcher.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level	           = "0,1,2,3,4,5,6", -- GW_T_LAUNCHER
	spawn_probability	   = "1,1,1,0,0,0,1", -- GW_T_LAUNCHER
	price =2000,
	mana = 50,
	max_uses	= 99, 
	custom_xml_file = "mods/mwp_gunwand/files/entities/misc/gw_t_launcher_extra.xml",
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile_trigger_death("mods/mwp_gunwand/files/actions/gw_t_launcher.xml", 6)
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.bounces = c.bounces + 2
		end
	end,
})

table.insert( actions,
{
	id 			= "GW_CLUSTER",
	name 		= "GW-Cluster Bombs",
	description = "Cluster bombs spell that triggers the next 6 spells in the wand after 0.5s. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_cluster.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level	           = "0,1,2,3,4,5,6", -- GW_CLUSTER
	spawn_probability	   = "1,0,1,0,1,0,1", -- GW_CLUSTER
	price =500,
	mana = 50,
	max_uses	= 99, 
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile_trigger_death("mods/mwp_gunwand/files/actions/gw_cluster.xml", 1)
			add_projectile_trigger_death("mods/mwp_gunwand/files/actions/gw_cluster_no_sound.xml", 1)
			add_projectile_trigger_death("mods/mwp_gunwand/files/actions/gw_cluster_no_sound.xml", 1)
			add_projectile_trigger_death("mods/mwp_gunwand/files/actions/gw_cluster_no_sound.xml", 1)
			add_projectile_trigger_death("mods/mwp_gunwand/files/actions/gw_cluster_no_sound.xml", 1)
			add_projectile_trigger_death("mods/mwp_gunwand/files/actions/gw_cluster_no_sound.xml", 1)
			c.fire_rate_wait = c.fire_rate_wait + 60
			c.bounces = c.bounces + 2
		end
	end,
})


table.insert( actions,
{
	id          = "GW_FLAMETHROWER",
	name 		= "GW-Flamethrower",
	description = "Flamethrower spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_flamethrower.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_FLAMETHROWER
	spawn_probability                 = "1,0,0,0,0,0,0", -- GW_FLAMETHROWER
	price = 800,
	mana = 5,
	max_uses = 999,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_flamethrower.xml")
			c.spread_degrees = 0
			c.fire_rate_wait = 2
		end
	end,
})

table.insert( actions,
{
	id          = "GW_RAILGUN",
	name 		= "GW-Railgun",
	description = "Railgun shell spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_railgun.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_RAILGUN
	spawn_probability                 = "0,0,0,0,0,0,0", -- GW_RAILGUN
	price = 3000,
	mana = 500,
	max_uses = 25,
	action 		= function()
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_railgun.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_railgun_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_railgun_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_railgun_no_sound.xml")
			add_projectile("mods/mwp_gunwand/files/actions/gw_railgun_no_sound.xml")
			c.fire_rate_wait = c.fire_rate_wait + 120
			c.spread_degrees = 0
			c.speed_multiplier = 1
			c.gore_particles    = c.gore_particles + 50
			c.damage_critical_chance = c.damage_critical_chance + 50
			shot_effects.recoil_knockback = shot_effects.recoil_knockback + 1000
			c.extra_entities = c.extra_entities .. "mods/mwp_gunwand/files/entities/misc/gw_burn.xml,"
		end
	end,
})

table.insert( actions,
{
	id          = "GW_LASER",
	name 		= "GW-Laser",
	description = "Laser spell. \n                                           ATTENTION: This spell requires GW-Adapter to function!",
	sprite 		= "mods/mwp_gunwand/files/actions/gw_laser.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "0,1,2,3,4,5,6", -- GW_LASER
	spawn_probability                 = "0,0,0,0,0,0,0", -- GW_LASER
	price = 5000,
	mana = 100,
	max_uses = -1,
	action 		= function()		
		local caster = GetUpdatedEntityID()
		local adapter_on = EntityHasTag(caster, "has_adapter")
		
		if adapter_on == true then
			add_projectile("mods/mwp_gunwand/files/actions/gw_laser.xml")
			c.fire_rate_wait = c.fire_rate_wait + 4
			c.spread_degrees = 0
			c.speed_multiplier = 1
			c.damage_critical_chance = c.damage_critical_chance + 25
		end
	end,
})
