dofile("data/scripts/lib/utilities.lua")
dofile_once("mods/mwp_gunwand/files/scripts/gw_extra_variables.lua")

local player = get_players()[1]
local x, y = EntityGetTransform(player)
local controlsComponent = EntityGetFirstComponent(player, "ControlsComponent")
local mouseR_Down = ComponentGetValue( controlsComponent, "mButtonDownFire2")
local crouch_Down = ComponentGetValue( controlsComponent, "mButtonDownDown")
local interact_Down = ComponentGetValue( controlsComponent, "mButtonDownInteract")
local guidedSprite = EntityGetWithTag("gw_guided")
local targetSprite = EntityGetWithTag("gw_target")
local mouseX, mouseY = DEBUG_GetMouseWorld()
local cameraX, cameraY = GameGetCameraPos()
local G_SpriteTarget = EntityGetFirstComponent(guidedSprite[1], "SpriteComponent", "gw_guided_sprite")
local T_SpriteTarget = EntityGetFirstComponent(targetSprite[1], "SpriteComponent", "gw_target_sprite")
local T_SpriteLight = EntityGetFirstComponent(targetSprite[1], "SpriteComponent", "gw_light_sprite")
local is_scope_on = ComponentGetValue(T_SpriteTarget, "visible")
local invComp = EntityGetFirstComponent(player, "Inventory2Component")
local actual_active = ComponentGetValue(invComp, "mActualActiveItem", eid)
local wand_deck = EntityGetAllChildren(actual_active)
local currentFrame = GameGetFrameNum()
local adapter_on = EntityHasTag(player, "has_adapter")
local this_missile = EntityGetClosestWithTag(x, y, "gw_guided_entity")


------------------------ ADAPTER CODE -------------------------------------------------


if (wand_deck ~= nil) then
	for i,this_spell in ipairs( wand_deck ) do
		local spell_idComp = EntityGetFirstComponent(this_spell, "ItemActionComponent")
		local spell_name = ComponentGetValue(spell_idComp, "action_id")
		
		if spell_name == "GW_ADAPTER" and adapter_on == false then
			EntityAddTag( player, "has_adapter" )
			ADAPTER_COUNTER = GameGetFrameNum()
			WAND_CHECK_A = actual_active
		end
	end
end
		
if actual_active ~= WAND_CHECK_A and adapter_on == true then
	EntityRemoveTag( player, "has_adapter" )
end

if currentFrame > ADAPTER_COUNTER + 60 and adapter_on == true then
	EntityRemoveTag( player, "has_adapter" )
end


------------------------ SCOPE CODE -------------------------------------------------


if (wand_deck ~= nil) then
	for i,this_spell in ipairs( wand_deck ) do
		local spell_idComp = EntityGetFirstComponent(this_spell, "ItemActionComponent")
		local spell_name = ComponentGetValue(spell_idComp, "action_id")
		
		if (tonumber(mouseR_Down)) == 1 and (tonumber(interact_Down)) == 1 and spell_name == "GW_SCOPE" and adapter_on == true and IS_PRESSING == false then			
			if IS_SCOPING == false then
				GameSetCameraFree(true)
				IS_SCOPING = true
				ComponentSetValue(T_SpriteTarget, "visible", 1)
				ComponentSetValue(T_SpriteLight, "visible", 1)
			elseif IS_SCOPING == true then
				GameSetCameraFree(false)
				IS_SCOPING = false
				ComponentSetValue(T_SpriteTarget, "visible", 0)
				ComponentSetValue(T_SpriteLight, "visible", 0)
			end
			IS_PRESSING = true
		end
		
		if spell_name == "GW_SCOPE" then
			WAND_CHECK = actual_active
			SCOPE_COUNTER = GameGetFrameNum()
		end
	end
end

if IS_SCOPING == true then
	EntitySetTransform(targetSprite[1], mouseX, mouseY)
	
	if (tonumber(is_scope_on)) == 1 then
		if cameraX <= x - 400 then
			GameSetCameraPos(x - 397, cameraY)
		end
		if cameraX >= x + 400 then
			GameSetCameraPos(x + 397, cameraY)
		end
		if cameraY <= y - 400 then
			GameSetCameraPos(cameraX, y - 397)
		end
		if cameraY >= y + 400 then
			GameSetCameraPos(cameraX, y + 397)
		end
	end
	
	GameSetCameraPos(x + ((mouseX - x) / 1.5), y + ((mouseY - y) / 1.5))
end

if (tonumber(mouseR_Down)) == 0 and (tonumber(interact_Down)) == 0 and IS_PRESSING == true then
	IS_PRESSING = false
end

if actual_active ~= WAND_CHECK then
	GameSetCameraFree(false)
	IS_SCOPING = false
	ComponentSetValue(T_SpriteTarget, "visible", 0)
	ComponentSetValue(T_SpriteLight, "visible", 0)
end

if currentFrame > SCOPE_COUNTER + 60 then
	GameSetCameraFree(false)
	IS_SCOPING = false
	ComponentSetValue(T_SpriteTarget, "visible", 0)
	ComponentSetValue(T_SpriteLight, "visible", 0)
end

-------------------- GUIDED MISSILE CODE --------------------------------------------


if (wand_deck ~= nil) then
	for i,this_spell in ipairs( wand_deck ) do
		local spell_idComp = EntityGetFirstComponent(this_spell, "ItemActionComponent")
		local spell_name = ComponentGetValue(spell_idComp, "action_id")
		
		if spell_name == "GW_MISSILE" then
			WAND_CHECK = actual_active
		end
		
		if (tonumber(mouseR_Down)) == 1 and spell_name == "GW_MISSILE" and adapter_on == true and IS_HOLDING == false then
			ComponentSetValue(G_SpriteTarget, "visible", 1)
			IS_HOLDING = true
		end
	end
end

EntitySetTransform(guidedSprite[1], mouseX, mouseY)

if (tonumber(mouseR_Down)) == 0 and IS_HOLDING == true then
	ComponentSetValue(G_SpriteTarget, "visible", 0)
	IS_HOLDING = false
	EntityKill(this_missile)
end

if actual_active ~= WAND_CHECK then
	ComponentSetValue(G_SpriteTarget, "visible", 0)
	IS_HOLDING = false
	EntityKill(this_missile)
end


-------------------- DETONATOR CODE --------------------------------------------


if (wand_deck ~= nil) then
	for i,this_spell in ipairs( wand_deck ) do
		local is_grenade = EntityHasTag(this_spell, "gw_launcher_active")
		
		if (tonumber(mouseR_Down)) == 1 and (tonumber(crouch_Down)) == 1 and is_grenade == true and IS_PRESSING_GL == false then
			local pipe_bombs = EntityGetWithTag( "gw_grenade" )
			if( #pipe_bombs > 0 ) then
				for i,v in ipairs(pipe_bombs) do
					EntityKill(v)
				end
			end
			IS_PRESSING_GL = true
		end
	end
end
		
if (tonumber(mouseR_Down)) == 0 and (tonumber(crouch_Down)) == 0 and IS_PRESSING_GL == true then	
	IS_PRESSING_GL = false
end