dofile_once( "mods/mwp_player_wizbot-01/files/scripts/kick_variables.lua") -- Variables stored outside to stop the script from resetting them.
dofile("data/scripts/lib/utilities.lua")


local player = get_players()[1]
local x, y = EntityGetTransform(player)
local controlsComponent = EntityGetFirstComponent(player, "ControlsComponent")
local kickDown = ComponentGetValue( controlsComponent, "mButtonDownKick")
local currentFrame = GameGetFrameNum()

edit_component( player, "CharacterDataComponent", function(comp,vars) -- Function that modifies player movement.
       
	local player_vel_x, player_vel_y = ComponentGetValueVector2( comp, "mVelocity")
    local aim_x, aim_y = ComponentGetValueVector2( controlsComponent, "mAimingVectorNormalized")

	if(tonumber(kickDown) == 1) and IS_KICKING == false and FRAME_KICKED == false then -- This stops the key press from happening every frame.
	
		if(aim_x > 0) then
			player_vel_x = player_vel_x + 1000
			EntityLoad("mods/mwp_player_wizbot-01/files/entities/particles/muzzle_flashes/gw_muzzle_boost.xml", x - 10, y - 10)
				local kright_entity = EntityGetInRadius(x + 14, y - 7, 20)
				for i,kright_id in ipairs( kright_entity ) do
					local physics = EntityGetFirstComponent( kright_id, "PhysicsBodyComponent" )					
					if ( physics ~= nil ) then
						local kright_vx, kright_vy = PhysicsGetComponentVelocity(kright_id, physics )
						local new_ry = kright_vy / 2
						PhysicsApplyForce(kright_id, 2000, new_ry)
					end
				end
		elseif(aim_x < 0) then
			player_vel_x = player_vel_x - 1000
			EntityLoad("mods/mwp_player_wizbot-01/files/entities/particles/muzzle_flashes/gw_muzzle_boost.xml", x + 10, y - 10)
			local foundEids = EntityGetWithTag("boost_tag")
			if (#foundEids > 0) then
				eid = foundEids[1]
				local x, y, rotation, scale_x, scale_y = EntityGetTransform(eid)
				local newRot = 3.14159 -- 180 degrees in radians
				EntitySetTransform(eid, x, y, newRot, scale_x, scale_y)
			end
			local kleft_entity = EntityGetInRadius(x - 14 ,y - 7, 20)
			for i,kleft_id in ipairs( kleft_entity ) do
				local physics = EntityGetFirstComponent( kleft_id, "PhysicsBodyComponent" )					
				if ( physics ~= nil ) then
					local kleft_vx, kleft_vy = PhysicsGetComponentVelocity(kleft_id, physics )
					local new_ly = kleft_vy / 2
					PhysicsApplyForce(kleft_id, -2000, new_ly)
				end
			end
		end
	
		IS_KICKING = true
		FRAME_KICKED = true
		FRAME_KICK_SNAPPED = GameGetFrameNum()
	end

	if(tonumber(kickDown) == 0) and IS_KICKING == true then -- This resets the key press variable.
		IS_KICKING = false
	end

	if currentFrame >= FRAME_KICK_SNAPPED + 39 and FRAME_KICKED == true then -- This prevents the key press from happening too soon.
		FRAME_KICKED = false
	end

	ComponentSetValueVector2( comp, "mVelocity", player_vel_x, player_vel_y)
end)