dofile("data/scripts/lib/utilities.lua")

local player = get_players()[1]
local x, y = EntityGetTransform(player)

local char_data = EntityGetFirstComponent( player, "CharacterDataComponent" )
local player_vel_x, player_vel_y = ComponentGetValueVector2( char_data, "mVelocity")

player_VT = player_vel_y
player_VB = player_vel_y
player_VL = player_vel_x
player_VR = player_vel_x

local surface_top, top_x, top_y = Raytrace(x - 9, y - 14, x + 9, y - 14)
local surface_bottom, bottom_x, bottom_y = Raytrace(x - 9, y, x + 9, y)
local surface_left, left_x, left_y = Raytrace(x - 9, y, x - 9, y - 14)
local surface_right, right_x, right_y = Raytrace(x + 9, y, x + 9, y - 14)

if surface_top == true then
	local top_entity = EntityGetInRadius(top_x, top_y, 5)
	for i,top_id in ipairs( top_entity ) do
		local physics = EntityGetFirstComponent( top_id, "PhysicsBodyComponent" )
		
		if player_vel_y <= 0 then
			player_VT = 0
		end
		
		if ( physics ~= nil ) then
			local top_vx, top_vy = PhysicsGetComponentVelocity(top_id, physics )
			local new_tx = top_vx / 2
			local new_ty = player_VT - 90
			PhysicsApplyForce(top_id, new_tx, new_ty)
		end
	end
end

if surface_bottom == true then
	local bottom_entity = EntityGetInRadius(bottom_x, bottom_y, 5)
	for i,bottom_id in ipairs( bottom_entity ) do
		local physics = EntityGetFirstComponent( bottom_id, "PhysicsBodyComponent" )
		
		if player_vel_y >= 0 then
			player_VB = 0
		end
		
		if ( physics ~= nil ) then
			local bottom_vx, bottom_vy = PhysicsGetComponentVelocity(bottom_id, physics )
			local new_bx = bottom_vx / 2
			local new_by = 20
			PhysicsApplyForce(bottom_id, new_bx, new_by)
		end
	end
end

if surface_left == true then
	local left_entity = EntityGetInRadius(left_x, left_y, 5)
	for i,left_id in ipairs( left_entity ) do
		local physics = EntityGetFirstComponent( left_id, "PhysicsBodyComponent" )
		
		if player_vel_x >= 0 then
			player_VL = 0
		end
		
		if ( physics ~= nil ) then
			local left_vx, left_vy = PhysicsGetComponentVelocity(left_id, physics )
			local new_lx = player_VL - 10
			local new_ly = left_vy / 2
			PhysicsApplyForce(left_id, new_lx, new_ly)
		end
	end
end

if surface_right == true then
	local right_entity = EntityGetInRadius(right_x, right_y, 5)
	for i,right_id in ipairs( right_entity ) do
		local physics = EntityGetFirstComponent( right_id, "PhysicsBodyComponent" )
		
		if player_vel_x <= 0 then
			player_VR = 0
		end
		
		if ( physics ~= nil ) then
			local right_vx, right_vy = PhysicsGetComponentVelocity(right_id, physics )
			local new_rx = player_VR + 10
			local new_ry = right_vy / 2
			PhysicsApplyForce(right_id, new_rx, new_ry)
		end
	end
end