ModLuaFileAppend( "data/scripts/gun/gun_extra_modifiers.lua", "mods/mwp_player_wizbot-01/files/scripts/no_recoil.lua" )

function OnPlayerSpawned( player_entity ) -- This runs when player entity has been created
	-- random loadout compatibility fix
	if tonumber(StatsGetValue("playtime")) < 1 then
		local armEntity = EntityGetWithName("arm_r")
		ComponentSetValue( EntityGetFirstComponent( armEntity, "SpriteComponent" ), "image_file", "mods/mwp_player_wizbot-01/data/enemies_gfx/player_arm.xml" )
		ComponentSetValue( EntityGetFirstComponent( player_entity, "SpriteComponent" ), "image_file", "mods/mwp_player_wizbot-01/data/enemies_gfx/player.xml" )
		ComponentSetValue( EntityGetFirstComponent( player_entity, "DamageModelComponent" ), "ragdoll_filenames_file", "mods/mwp_player_wizbot-01/data/ragdolls/player/filenames.txt" )
		
		local spriteComp = EntityGetFirstComponent( player_entity, "SpriteComponent", "character" )
		ComponentSetValue(spriteComp, "offset_x", 9)
		ComponentSetValue(spriteComp, "offset_y", 15)
		
		EntityAddTag(player_entity, "robot")
		
		local damageComp = EntityGetFirstComponent( player_entity, "DamageModelComponent" )
		ComponentSetValue(damageComp, "air_needed", 0)
		ComponentSetValue(damageComp, "fire_probability_of_ignition", 0)
		ComponentSetValue(damageComp, "hp", 8)
		ComponentSetValue(damageComp, "materials_that_damage", "acid,lava,blood_cold_vapour,blood_cold,poison,radioactive_gas,radioactive_gas_static,rock_static_radioactive,rock_static_poison,ice_radioactive_static,ice_radioactive_glass,ice_acid_static,ice_acid_glass,rock_static_cursed")
		ComponentSetValue(damageComp, "materials_how_much_damage", "0.005,0.003,0.0006,0.0009,0.001,0.001,0.001,0.001,0.001,0.001,0.001,0.005")
		ComponentSetValue(damageComp, "blood_spray_material", "oil")
		ComponentSetValue(damageComp, "minimum_knockback_force", 99999)
		ComponentSetValue(damageComp, "blood_material", "oil")
		ComponentSetValue(damageComp, "ragdoll_material", "steel")
		ComponentObjectSetValue(damageComp, "damage_multipliers", "fire", 0.0)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "drill", 0.1)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "slice", 0.1)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "melee", 0.3)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "projectile", 0.5)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "radioactive", 1.5)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "explosion", 1.0)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "electricity", 2.0)
		ComponentObjectSetValue(damageComp, "damage_multipliers", "poison", 0.0)
		
		local audioComp = EntityGetFirstComponent( player_entity, "AudioComponent" )
		EntityRemoveComponent(player_entity, audioComp)
		
		local audiojetpackComp = EntityGetFirstComponent( player_entity, "AudioLoopComponent", "sound_jetpack" )
		EntityRemoveComponent(player_entity, audiojetpackComp)
		
		local kickComp = EntityGetFirstComponent( player_entity, "KickComponent" )
		ComponentSetValue(kickComp, "kick_radius", 0)
		
		-- EntityAddComponent( player_entity, "ExplodeOnDamageComponent",
		-- {
			-- explode_on_death_percent="1",
			-- explode_on_damage_percent="0.0"
		-- } )	
		
		-- local explosionComp = EntityGetFirstComponent( player_entity, "ExplodeOnDamageComponent" )	
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "never_cache", 1)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "camera_shake", 60)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "explosion_radius", 70)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "explosion_sprite", "")
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "load_this_entity", "mods/mwp_player_wizbot-01/files/entities/misc/gw_loose_player.xml,mods/mwp_player_wizbot-01/files/entities/particles/image_emitters/gw_boom_sprite_player.xml")
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "explosion_sprite_lifetime", 0)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "create_cell_probability", 5)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "hole_destroy_liquid", 0)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "hole_enabled", 1)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "ray_energy", 6700000)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "damage", 5)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "particle_effect", 1)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "damage_mortals", 1)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "shake_vegetation", 1)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "sparks_count_max", 500)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "sparks_count_min", 500)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "sparks_enabled", 1)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "stains_enabled", 1)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "stains_radius", 35)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "background_lightning_count", 0)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "max_durability_to_destroy", 12)
		-- ComponentObjectSetValue(explosionComp, "config_explosion", "audio_event_name", "explosion_nuke")
		-- ComponentSetValueValueRange(explosionComp, "config_explosion", "physics_explosion_power", 4.5, 9)
		
		
		EntityAddComponent( player_entity, "AudioLoopComponent",
		{
			file="data/audio/Desktop/animals.snd",
			event_name="animals/tank/movement_loop",
			set_speed_parameter_only_based_on_x_movement="0",
			set_speed_parameter="1",
			auto_play="1"
		} )	
		
		EntityAddComponent( player_entity, "AudioComponent",
		{
			file="data/audio/Desktop/animals.snd",
			event_root="animals/robot",
			set_latest_event_position="1"
		} )	
		
		EntityAddComponent( player_entity, "ShotEffectComponent",
		{
			extra_modifier="no_recoil"
		} )	


		-- Removes default jetpack
		EntitySetComponentsWithTagEnabled( player_entity, "jetpack", 1 )
		local old_jetpack = EntityGetFirstComponent( player_entity, "ParticleEmitterComponent")
		EntityRemoveComponent( player_entity, old_jetpack )

		
		-- Aiming reticle fix
		local old_hitbox = EntityGetFirstComponent( player_entity, "HitboxComponent" )
		ComponentSetValue(old_hitbox, "aabb_max_x", 2)
		ComponentSetValue(old_hitbox, "aabb_min_x", -2)
		ComponentSetValue(old_hitbox, "aabb_max_y", -4)
		ComponentSetValue(old_hitbox, "aabb_min_y", -12)
		
		EntityAddComponent( player_entity, "HitboxComponent",
		{
			aabb_max_x="6",
			aabb_max_y="4", 
			aabb_min_x="-6", 
			aabb_min_y="-12", 
			is_enemy="0", 
			is_item="0", 
			is_player="1"
		} )	

		-- Remove cape
		local plyChildEnt = EntityGetAllChildren( player_entity )
		if ( plyChildEnt ~= nil ) then
			for i,childEntity in ipairs( plyChildEnt ) do
				if ( EntityGetName( childEntity ) == "cape" ) then
					EntityKill( childEntity )
					break
				end
			end
		end
		
		-- Adds a new LUA component
		EntityAddComponent( player_entity, "LuaComponent",
		{
		  remove_after_executed="0",
		  execute_times="-1",
		  script_source_file="mods/mwp_player_wizbot-01/files/scripts/gw_booster_kick.lua"
		} )
		EntityAddComponent( player_entity, "LuaComponent",
		{
		  remove_after_executed="0",
		  execute_times="-1",
		  script_source_file="mods/mwp_player_wizbot-01/files/scripts/velocity_fix.lua"
		} )
		EntityAddComponent( player_entity, "LuaComponent",
		{
		  remove_after_executed="0",
		  execute_times="-1",
		  script_source_file="mods/mwp_player_wizbot-01/files/scripts/gw_physics_collision.lua"
		} )
		EntityAddComponent( player_entity, "LuaComponent",
		{
		  remove_after_executed="0",
		  execute_times="-1",
		  script_source_file="mods/mwp_player_wizbot-01/files/scripts/gw_jet_sound.lua"
		} )
	end
end